//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#include "common.hh"

#include "parse/libparse.hh"

#include "inst/program_solver.hh"

#include "parse-tasks.hh"
#include "inst-tasks.hh"

// Inst module related tasks' implementation.
namespace inst
{

  namespace tasks
  {

    void
    prg_display ()
    {
      std::cout << *parse::tasks::program << std::endl;
    }

    void
    prg_solve ()
    {
      inst::ProgramSolver program_solver;
      program_solver.set_max_callee_save(max_callee_save);
      program_solver.set_max_caller_save(max_caller_save);
      program_solver.set_max_args(max_args);
      program_solver.enable_unlimited_regs(parse::unlimited_regs_p);
      program_solver.solve(* parse::tasks::program);
      if (exit_status != exit_success)
        exit (exit_status);
    }

  } // namespace tasks

} // namespace inst
