//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef INST_EXP_HXX
# define INST_EXP_HXX

# include "inst/exp.hh"

# include "misc/contract.hh"

namespace inst
{

  //
  inline
  Exp::Exp():
    immediate_(0)
  {
  }

  //
  inline void
  Exp::set_immediate(int i)
  {
    precondition(!locked());
    lock();

    immediate_ = i;
  }
  inline int
  Exp::get_immediate() const
  {
    precondition(locked());

    return immediate_;
  }

  inline
  Exp::operator int () const
  {
    return get_immediate();
  }

  //
  inline std::ostream &
  operator<<(std::ostream &ostr, const Exp &e)
  {
    e.write(ostr);
    return ostr;
  }

} // namespace inst

#endif // !INST_EXP_HXX
